From b272a27279cc3ca0fdd8388ed1583aada75c1b8d Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Wed, 29 May 2019 10:47:46 -0700
Subject: [PATCH] Send Hello reply for a recieved Hello message

Change-Id: Ibe5229f36819fc894732af8f3944d65421d0dfb0
---
 net/ipc_router/ipc_router_core.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/net/ipc_router/ipc_router_core.c b/net/ipc_router/ipc_router_core.c
index 14dbed8..2ecefb4 100644
--- a/net/ipc_router/ipc_router_core.c
+++ b/net/ipc_router/ipc_router_core.c
@@ -150,6 +150,7 @@ struct msm_ipc_router_xprt_info {
 	struct kref ref;
 	struct completion ref_complete;
 	bool hello_sent;
+	bool hello_rcvd;
 };
 
 #define RT_HASH_SIZE 4
@@ -2476,7 +2477,7 @@ static int do_send_hello_msg(struct msm_ipc_router_xprt_info *xprt_info)
 	union rr_control_msg ctl;
 	int rc = 0;
 
-	if (xprt_info->hello_sent)
+	if (xprt_info->hello_sent && xprt_info->hello_rcvd)
 		return 0;
 
 	memset(&ctl, 0, sizeof(ctl));
@@ -2516,6 +2517,10 @@ static int process_hello_msg(struct msm_ipc_router_xprt_info *xprt_info,
 	do_version_negotiation(xprt_info, msg);
 	do_send_hello_msg(xprt_info);
 	xprt_info->initialized = 1;
+        if (xprt_info->hello_rcvd == true)
+		IPC_RTR_ERR("Recieved duplicate Hello message for XPRT %s \n",
+				 xprt_info->xprt->name);
+        xprt_info->hello_rcvd = true;
 
 	/* Send list of servers from the local node and from nodes
 	 * outside the mesh network in which this XPRT is part of.
@@ -4099,6 +4104,7 @@ static int msm_ipc_router_add_xprt(struct msm_ipc_router_xprt *xprt)
 	up_write(&xprt_info_list_lock_lha5);
 
 	xprt_info->hello_sent = false;
+	xprt_info->hello_rcvd = false;
 	do_send_hello_msg(xprt_info);
 
 	down_write(&routing_table_lock_lha3);
-- 
1.9.1

